// TIRQThread.cpp : implementation file
//

#include "stdafx.h"
#include "AQS.h"
#include "AQSDlg.h"

#include "AIO167.h"
#include "AIO16A.h"
#include "TIRQThread.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



extern UINT32 QUADCardNum;
extern UINT32 QUADBase;
extern int ComNum;

/////////////////////////////////////////////////////////////////////////////
// TIRQThread

IMPLEMENT_DYNCREATE(TIRQThread, CWinThread)

TIRQThread::TIRQThread(void)
{
}

TIRQThread::~TIRQThread(void)
{
}

BOOL TIRQThread::InitInstance(void)
{
	return TRUE;
}



BEGIN_MESSAGE_MAP(TIRQThread, CWinThread)
	//{{AFX_MSG_MAP(TIRQThread)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// TIRQThread message handlers

int TIRQThread::Run(void)
{
	const char HexChar[] = "0123456789ABCDEF";

	UINT16 ADData[16];
	UINT32 QuadData[8];
	CString Buf;
	HANDLE hCom;
	DWORD BytesTransferred;
	DCB ComDCB;

	UINT32 ReturnValue = ERROR_SUCCESS;

	Buf.Format(_T("%d"), ComNum);
	Buf = "\\\\.\\COM" + Buf;
	hCom = CreateFile(Buf, GENERIC_WRITE | GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, 0);

	SetupComm(hCom, 1026, 255);  // In buffer = 1026 bytes, out buffer = 255 bytes
	GetCommState(hCom, &ComDCB);  // Fill ComDCB with current data
	ComDCB.BaudRate = 115200;
	ComDCB.ByteSize = 8;
	ComDCB.Parity   = NOPARITY;
	ComDCB.StopBits = ONESTOPBIT;
	SetCommState(hCom, &ComDCB);

	do
	{
		ReturnValue = WaitForIRQData(AIO16CardNum, sizeof(ADData), ADData);
		if(ReturnValue != ERROR_SUCCESS)
			break
		;

		for( int i = 0;  i < 8; i++)
			QuadData[i] = Read_7266_OL(QUADBase + i * 2)
		;


		// We're only going at 60Hz, so we can do the string processing now.

		Buf = "";
		if ( bReportQuad )  // This sample just reports one or the other.
		{
			for ( int I = 0; I <= 7; ++I )
			{
				CString Hex;
				Hex.Format("%06X,", QuadData[I]);
				Buf += Hex;
			}
		}
		else
		{
			for (int I = 0; I <= 15; ++I )
			{
				CString Hex;
				Hex.Format("%04X,", ADData[I]);
				Buf += Hex;
			}
		}

		char * pBuf = Buf.GetBuffer();
		int Len = Buf.GetLength();
		pBuf[Len-1] = '\r';  // Change the last comma to an enter.

		WriteFile(hCom, pBuf, Len, &BytesTransferred, NULL);
		Buf = "";

	} while (! bTerminated);

	// Stop the A/D counters by moding them.
	CtrMode(AIO16CardNum, 1, 2);
	CtrMode(AIO16CardNum, 2, 2);

	CloseHandle(hCom);

	PostMessage(hMainForm, AM_THREADEND, 0, 0);

	// Call base class
	return CWinThread::Run();
}
